﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace WpfApplication2
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		DispatchableObservableCollection<int> a;
		public MainWindow()
		{
			InitializeComponent();
			a = new DispatchableObservableCollection<int>();
			a.CollectionChanged += a_CollectionChanged;
		}

		void a_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
		{

		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			a.Add(1);
		}
	}

	public class DispatchableObservableCollection<T>
		: ObservableCollection<T>
	{
		public override event NotifyCollectionChangedEventHandler CollectionChanged;

		protected override void OnCollectionChanged(NotifyCollectionChangedEventArgs e)
		{
			Delegate[] delegates = CollectionChanged.GetInvocationList();

			foreach (NotifyCollectionChangedEventHandler handler in delegates)
			{
				var target = handler.Target as DispatcherObject;
				target.Dispatcher.Invoke((new Action(() => { MessageBox.Show(target.ToString() + " calls me"); })));
			}
		}
	}
}